from collections import deque

n, m, k = map(int, input().split())
graph = [[] for _ in range(n + 1)]

for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

guards = []
for _ in range(k):
    p, h = map(int, input().split())
    guards.append((p, h))

protected = set()

def bfs(start, max_distance):
    queue = deque([(start, 0)])
    visited = set()

    while queue:
        current, distance = queue.popleft()

        if distance > max_distance:
            continue

        if current not in visited:
            visited.add(current)
            protected.add(current)

            for neighbor in graph[current]:
                if neighbor not in visited:
                    queue.append((neighbor, distance + 1))
                    
for p, h in guards:
    bfs(p, h)

print(len(protected))
print(' '.join(map(str, sorted(protected))))
